summaryrefslogtreecommitdiff
path: root/scripts/oe-setup-builddir
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/oe-setup-builddir')
-rwxr-xr-xscripts/oe-setup-builddir114
1 files changed, 68 insertions, 46 deletions
diff --git a/scripts/oe-setup-builddir b/scripts/oe-setup-builddir
index a869fdc7c0..ef495517aa 100755
--- a/scripts/oe-setup-builddir
+++ b/scripts/oe-setup-builddir
@@ -23,94 +23,116 @@ if [ -z "$BUILDDIR" ]; then
exit 1
fi
-mkdir -p $BUILDDIR/conf
+if [ "$1" = '--help' -o "$1" = '-h' ]; then
+ echo 'Usage: oe-setup-builddir'
+ echo ''
+ echo "OpenEmbedded setup-builddir - setup build directory $BUILDDIR"
+ echo ''
+ exit 2
+fi
+
+mkdir -p "$BUILDDIR/conf"
-if ! (test -d "$BUILDDIR"); then
+if [ ! -d "$BUILDDIR" ]; then
echo >&2 "Error: The builddir ($BUILDDIR) does not exist!"
exit 1
fi
-if ! (test -w "$BUILDDIR"); then
+if [ ! -w "$BUILDDIR" ]; then
echo >&2 "Error: Cannot write to $BUILDDIR, perhaps try sourcing with a writable path? i.e. . oe-init-build-env ~/my-build"
exit 1
fi
+# Attempting removal of sticky,setuid bits from BUILDDIR, BUILDDIR/conf
+chmod -st "$BUILDDIR" 2>/dev/null || echo "WARNING: unable to chmod $BUILDDIR"
+chmod -st "$BUILDDIR/conf" 2>/dev/null || echo "WARNING: unable to chmod $BUILDDIR/conf"
+
cd "$BUILDDIR"
-TEMPLATECONF=${TEMPLATECONF:-meta/conf}
+if [ -f "$BUILDDIR/conf/templateconf.cfg" ]; then
+ TEMPLATECONF=$(cat "$BUILDDIR/conf/templateconf.cfg")
+fi
+
+. $OEROOT/.templateconf
+
+if [ ! -f "$BUILDDIR/conf/templateconf.cfg" ]; then
+ echo "$TEMPLATECONF" >"$BUILDDIR/conf/templateconf.cfg"
+fi
#
# $TEMPLATECONF can point to a directory for the template local.conf & bblayers.conf
#
-if [ "x" != "x$TEMPLATECONF" ]; then
- if ! (test -d "$TEMPLATECONF"); then
- # Allow TEMPLATECONF=meta-xyz/conf as a shortcut
- if [ -d "$OEROOT/$TEMPLATECONF" ]; then
- TEMPLATECONF="$OEROOT/$TEMPLATECONF"
- fi
- if ! (test -d "$TEMPLATECONF"); then
- echo >&2 "Error: '$TEMPLATECONF' must be a directory containing local.conf & bblayers.conf"
- return
- fi
+if [ -n "$TEMPLATECONF" ]; then
+ if [ ! -d "$TEMPLATECONF" ]; then
+ # Allow TEMPLATECONF=meta-xyz/conf as a shortcut
+ if [ -d "$OEROOT/$TEMPLATECONF" ]; then
+ TEMPLATECONF="$OEROOT/$TEMPLATECONF"
+ fi
+ if [ ! -d "$TEMPLATECONF" ]; then
+ echo >&2 "Error: TEMPLATECONF value points to nonexistent directory '$TEMPLATECONF'"
+ exit 1
+ fi
fi
OECORELAYERCONF="$TEMPLATECONF/bblayers.conf.sample"
OECORELOCALCONF="$TEMPLATECONF/local.conf.sample"
OECORENOTESCONF="$TEMPLATECONF/conf-notes.txt"
fi
-if [ "x" = "x$OECORELOCALCONF" ]; then
+unset SHOWYPDOC
+if [ -z "$OECORELOCALCONF" ]; then
OECORELOCALCONF="$OEROOT/meta/conf/local.conf.sample"
fi
-if ! (test -r "$BUILDDIR/conf/local.conf"); then
-cat <<EOM
+if [ ! -r "$BUILDDIR/conf/local.conf" ]; then
+ cat <<EOM
You had no conf/local.conf file. This configuration file has therefore been
-created for you with some default values. You may wish to edit it to use a
-different MACHINE (target hardware) or enable parallel build options to take
-advantage of multiple cores for example. See the file for more information as
-common configuration options are commented.
-
-The Yocto Project has extensive documentation about OE including a reference manual
-which can be found at:
- http://yoctoproject.org/documentation
-
-For more information about OpenEmbedded see their website:
- http://www.openembedded.org/
+created for you with some default values. You may wish to edit it to, for
+example, select a different MACHINE (target hardware). See conf/local.conf
+for more information as common configuration options are commented.
EOM
- cp -f $OECORELOCALCONF $BUILDDIR/conf/local.conf
+ cp -f $OECORELOCALCONF "$BUILDDIR/conf/local.conf"
+ SHOWYPDOC=yes
fi
-if [ "x" = "x$OECORELAYERCONF" ]; then
+if [ -z "$OECORELAYERCONF" ]; then
OECORELAYERCONF="$OEROOT/meta/conf/bblayers.conf.sample"
fi
-if ! (test -r "$BUILDDIR/conf/bblayers.conf"); then
-cat <<EOM
-You had no conf/bblayers.conf file. The configuration file has been created for
-you with some default values. To add additional metadata layers into your
-configuration please add entries to this file.
-
-The Yocto Project has extensive documentation about OE including a reference manual
-which can be found at:
- http://yoctoproject.org/documentation
-
-For more information about OpenEmbedded see their website:
- http://www.openembedded.org/
-
+if [ ! -r "$BUILDDIR/conf/bblayers.conf" ]; then
+ cat <<EOM
+You had no conf/bblayers.conf file. This configuration file has therefore been
+created for you with some default values. To add additional metadata layers
+into your configuration please add entries to conf/bblayers.conf.
EOM
# Put the abosolute path to the layers in bblayers.conf so we can run
# bitbake without the init script after the first run
- sed "s|##OEROOT##|$OEROOT|g" $OECORELAYERCONF > $BUILDDIR/conf/bblayers.conf
# ##COREBASE## is deprecated as it's meaning was inconsistent, but continue
# to replace it for compatibility.
- sed -i -e "s|##COREBASE##|$OEROOT|g" $BUILDDIR/conf/bblayers.conf
+ sed -e "s|##OEROOT##|$OEROOT|g" \
+ -e "s|##COREBASE##|$OEROOT|g" \
+ $OECORELAYERCONF > "$BUILDDIR/conf/bblayers.conf"
+ SHOWYPDOC=yes
fi
# Prevent disturbing a new GIT clone in same console
unset OECORELOCALCONF
unset OECORELAYERCONF
+# Ending the first-time run message. Show the YP Documentation banner.
+if [ ! -z "$SHOWYPDOC" ]; then
+ cat <<EOM
+The Yocto Project has extensive documentation about OE including a reference
+manual which can be found at:
+ http://yoctoproject.org/documentation
+
+For more information about OpenEmbedded see their website:
+ http://www.openembedded.org/
+
+EOM
+# unset SHOWYPDOC
+fi
+
cat <<EOM
### Shell environment set up for builds. ###
@@ -118,7 +140,7 @@ cat <<EOM
You can now run 'bitbake <target>'
EOM
-if [ "x" = "x$OECORENOTESCONF" ]; then
+if [ -z "$OECORENOTESCONF" ]; then
OECORENOTESCONF="$OEROOT/meta/conf/conf-notes.txt"
fi
[ ! -r "$OECORENOTESCONF" ] || cat $OECORENOTESCONF